<template>
    <div class="layout-center">
        <div class="layout-border" style="background: rgb(255, 255, 255); padding: 24px">
            <a-typography-title :level="3" :style="{ marginBottom: '36px', textAlign: 'left' }">Register</a-typography-title>

            <a-form
                :label-col="{ style: { width: '40%', textAlign: 'left' } }"
                :wrapper-col="{ style: { width: '40%' } }"
                :model="formState"
                :rules="rules"
                name="normal_login"
                class="login-form"
                :style="{ width: '450px' }"
                @finish="onFinish"
                @finishFailed="onFinishFailed"
            >
                <a-form-item label="Username" name="name" :rules="[{ required: true, message: 'Please input your username!' }]">
                    <a-input v-model:value="formState.name" />
                </a-form-item>

                <a-form-item
                    label="Email"
                    name="email"
                    :rules="[
                        { required: true, message: 'Please input your email!' },
                        { type: 'email', message: 'Email Invalid' },
                    ]"
                >
                    <a-input v-model:value="formState.email" />
                </a-form-item>

                <a-form-item label="Password" name="password" :rules="[{ required: true, message: 'Please input your password!' }]">
                    <a-input-password v-model:value="formState.password" type="password" autocomplete="off" />
                </a-form-item>

                <a-form-item label="Password Confirm" name="password_confirmation">
                    <a-input-password v-model:value="formState.password_confirmation" type="password" autocomplete="off" />
                </a-form-item>

                <a-typography-text type="danger" v-if="errors">*{{ errors }}</a-typography-text>

                <a-form-item :style="{textAlign: 'left', marginTop: '12px'}">
                    <a-button type="primary" html-type="submit">Submit</a-button>
                    Or
                    <a-typography-link href="/login">Login now!</a-typography-link>
                </a-form-item>
            </a-form>
        </div>
    </div>
</template>
<script lang="ts" setup>
import { reactive } from "vue";
import type { Rule } from "ant-design-vue/es/form";
import { message } from "ant-design-vue";

interface FormState {
    name: string;
    email: string;
    password: string;
    password_confirmation: string;
}

const formState = reactive<FormState>({
    name: "",
    email: "",
    password: "",
    password_confirmation: "",
});

const validateConfirmPassword = async (_rule: Rule, value: string) => {
    if (value === "") {
        return Promise.reject("Please input the password confirmation!");
    } else if (value !== formState.password) {
        return Promise.reject("The passwords confirm don't match!");
    }
    return Promise.resolve();
};

const rules: Record<string, Rule[]> = {
    password_confirmation: [{ required: true, validator: validateConfirmPassword, trigger: "change" }],
};

const authStore = useAuthStore();
const userStore = useUserStore();
const { isLoaded } = storeToRefs(userStore);

const router = useRouter();


let errors = ref(null);

const onFinish = async (values: any) => {
    errors.value = null;
    isLoaded.value = true;
    try {
        await authStore.register(values);
        message.success("Register success! Please login.");
        router.push({ path: "/login" });
    } catch (error: any) {
        errors.value = error.response.data.message;
    } finally {
        isLoaded.value = false;
    }
};

const onFinishFailed = (errorInfo: any) => {
    console.log("Failed:", errorInfo);
};
</script>

<style scoped>
.layout-center {
    display: flex;
    justify-content: center;
    align-items: center;
    height: 100vh;
}
</style>
